<?php
namespace Env\Plugins { class PluginSet extends \Ext\Source\Instances { const LOADED = 2; const MAIN_FILE_INACCESIBLE = 4; public $status; protected $config, $devkit, $event_handler, $name, $plugins = array(); public function &getPluginInstance($instance_id = '') { try { return $this->getInstance($instance_id, array($this->name, &$this->config, &$this->devkit, &$this->event_handler)); } catch (\HunterException $e) { \Artise::hunter()->error($e); $empty_object = new \Env\Source\EmptyObject('...->lang()'); return $empty_object; } } public function __construct(&$devkit, $plugin_name) { $this->name = $plugin_name; $this->devkit = &$devkit; $main_file = Artise_Path_Plugins . \DS . $plugin_name . \DS . $plugin_name . '.php'; if(!is_readable($main_file)) { $this->status = self::MAIN_FILE_INACCESIBLE; return; } include_once $main_file; $this->instances_class_path = '\plugins\\' . $plugin_name . '\Main'; try { $config = null; $file_path = Artise_Path_Plugins . DS . $plugin_name . '/config.xml'; if(file_exists($file_path)) $config = \Env\Config\Loader::load($file_path, $errors); } catch (\HunterException $e) { $devkit->hunter()->error($e); } $this->config = &$config; $this->event_handler = new \Env\Events\Handler(); $this->loadListeners(); $this->status = self::LOADED; } protected function &devkit() { return $this->devkit; } private function loadListeners() { $filename = Artise_Path_Plugins . DS . $this->name . '/listeners.xml'; if(!file_exists($filename)) return false; try { if(!is_readable($filename)) throw new \HunterException( new \Env\Source\DummyIdiom('E0051', array('element' => 'listeners')), new \Env\Source\DummyIdiom('file_path', array('path' => $filename)), 'TIP_E0051'); $xml = secure_simplexml_load_file($filename, $errors); if($xml) { $this->parseListeners($xml, $filename); return true; } else { throw new \HunterException( 'E0003', array('file_path', array('path' => $filename)), 'TIP_E0031'); } } catch (\HunterException $e) { $this->devkit()->hunter()->error($e); } return false; } private function parseListeners($xml, $filename) { foreach($xml as $listen) { try { if (!property_exists($listen, 'event')) throw new \HunterException('W0010', '', 'TIP_W0010'); if (!property_exists($listen, 'callback')) throw new \HunterException('W0011', '', 'TIP_W0011'); $event = (string)$listen->event->attributes()->value; $parts = explode(':', $event); $callback_method = (string)$listen->callback->attributes()->value; $instance = property_exists($listen, 'instance') ? (string)$listen->instance->attributes()->value : ''; $plugin_instance = $this->getPluginInstance($instance); switch($parts[0]) { case 'env': \Artise::event()->addListener($event, array(&$plugin_instance, $callback_method)); break; case 'plugins': $plugin_name = $parts[1]; if($this->devkit()->plugins()->manifest($plugin_name)) { $this->devkit()->plugins()->$plugin_name()->event()->addListener($parts[2], array(&$plugin_instance, $callback_method)); } else { throw new \HunterException( new \Env\Source\DummyIdiom('W0013', array('plugin' => $plugin_name)), new \Env\Source\DummyIdiom('file_path', array('path' => $filename)), 'TIP_E0010'); } break; default: throw new \HunterException( new \Env\Source\DummyIdiom('W0012', array('expression' => $event)), new \Env\Source\DummyIdiom('file_path', array('path' => $filename)), 'TIP_W0012'); break; } } catch (\HunterException $e) { $this->devkit()->hunter()->warning($e); } } } } } ?>
