<?php
namespace Ext\Rendering\Painter { class Palette { const oTagLen = 10; const oTagEndLen = 3; const cTagLen = 13; private $htmlBlocks = array(); private $varBlocks = array(); protected $filename = ''; protected $html = '', $phrases; final public function set($filename) { $this->filename = $filename; } public function __construct($filename) { $this->set($filename); } final private function load() { if($this->filename) { $path = \Artise::router()->getPath(Artise_Path_Palettes) . DS; $filename = $path . $this->filename . '.html'; if(!file_exists($filename)) throw new \HunterException( new \Env\Source\DummyIdiom('E0050', array('element' => 'Palette')), new \Env\Source\DummyIdiom('file_path_abstract', array( 'path' => $path, 'filename' => $this->filename)), 'TIP_E0050'); if(!is_readable($filename)) throw new \HunterException( new \Env\Source\DummyIdiom('E0051', array('element' => 'Palette')), new \Env\Source\DummyIdiom('file_path_abstract', array( 'path' => $path, 'filename' => $this->filename)), 'TIP_E0051'); $this->html = file_get_contents($filename); $this->phrases = $this->matchPhrases(); } else { throw new \HunterException( new \Env\Source\DummyIdiom('W0050', array('element' => 'Palette')), null, 'TIP_E0050'); } } final public function __toString() { try { if(!$this->html) $this->load(); if(!$this->htmlBlocks) { $this->checkIntegrity(); $this->replacePhrases(); $this->htmlBlocks = array( 'root' => array ( 'html' => $this->html, 'blocks' => $this->parseBlocks($this->html) ) ); } return restoreTokens(restoreSlashedTokens($this->merge($this->varBlocks, $this->htmlBlocks))); } catch(\HunterException $e) { \Artise::hunter()->error($e); return ''; } } public function setVarBlocks(array $blocks) { $this->varBlocks = &$blocks; } private function checkIntegrity() { preg_match_all('#<!--block:(.*?)-->#s', $this->html, $openingMatches); preg_match_all('#<!--/block-->#s', $this->html, $closingMatches); if(!(count($openingMatches[0]) === count($closingMatches[0]))) { throw new \HunterException( 'E0033', new \Env\Source\DummyIdiom('file_path', array('path' => $this->filename)), 'TIP_E0033'); } } private function parseBlocks(&$html) { $blocksArray = array(); $oBlocks = 0; $offset = 0; $oTagPos = 0; $cTagPos = 0; $mBlock = array(); while(true) { $oTagPos = strpos($html, '<!--block:', $offset); $cTagPos = strpos($html, '<!--/block-->', $offset); if(false === $oTagPos && false !== $cTagPos) $oTagPos = $cTagPos + 1; if($oTagPos < $cTagPos) { ++$oBlocks; $charPos = $oTagPos + self::oTagLen; $style = ''; while(substr($html, $charPos, self::oTagEndLen) !== '-->') { $style .= substr($html, $charPos, 1); ++$charPos; } $offset = $charPos; if(!isset($mBlock['style'])) { $mBlock['style'] = $style; $mBlock['pos'] = $offset + self::oTagEndLen; } } elseif($cTagPos < $oTagPos) { --$oBlocks; $offset = $cTagPos + self::cTagLen; if(0 === $oBlocks) { $blocksArray[$mBlock['style']] = array(); $blocksArray[$mBlock['style']]['html'] = substr($html, $mBlock['pos'], $offset - $mBlock['pos'] - self::cTagLen); $blocksArray[$mBlock['style']]['blocks'] = $this->parseBlocks($blocksArray[$mBlock['style']]['html']); $mBlock = array(); } } else { break; } } return $blocksArray; } private function cleanWastedBlocks($html) { $oBlocks = 0; $offset = 0; $oTagPos = 0; $cTagPos = 0; while(true) { $oTagPos = strpos($html, '<!--block:', $offset); $cTagPos = strpos($html, '<!--/block-->', $offset); if(false === $oTagPos && false !== $cTagPos) { $oTagPos = $cTagPos + 1; } if($oTagPos < $cTagPos) { ++$oBlocks; $offset = $oTagPos + self::oTagLen; if(!isset($blockPos['ini'])) $blockPos['ini'] = $oTagPos; } elseif($cTagPos < $oTagPos) { --$oBlocks; $offset = $cTagPos + self::cTagLen + 1; if(0 === $oBlocks) { $blockPos['end'] = $offset; $html = substr_replace($html, '', $blockPos['ini'], ($blockPos['end'] - $blockPos['ini'] - 1)); $offset = $blockPos['ini']; $blockPos = array(); } } else { break; } } return $html; } private function merge(array &$varBlocks, array &$htmlBlocks) { $html = ''; $blockPos = array(); foreach($varBlocks as $block) { if(!isset($htmlBlocks[$block['style']])) throw new \HunterException('E0036', $block['style']); $blockHtml = $htmlBlocks[$block['style']]['html']; if(count($block['blocks']) > 0) { $htmlIntBlocks = $this->merge($block['blocks'], $htmlBlocks[$block['style']]['blocks']); $pointer = strpos($blockHtml, '<!--block:'); $html .= substr_replace($blockHtml, $htmlIntBlocks, $pointer, 0); } else { $html .= $blockHtml; } sortByKeyLength($block['vars']); foreach($block['vars'] as $name => $value) { $html = str_replace('%' . $name, slashTokens(slashSlashedTokens($value)), $html); } } return $this->cleanWastedBlocks($html); } final private function matchPhrases() { preg_match_all('#\@([a-zA-Z0-9_]+)#s', $this->html, $matches); arsort($matches[1]); return $matches[1]; } final private function replacePhrases() { foreach($this->phrases as $phrase) { if(\Artise::lang()->phraseExists($phrase)) { $value = \Artise::lang()->phrase($phrase, array()); $this->html = str_replace('@' . $phrase, slashTokens(slashSlashedTokens($value)), $this->html); } } } final public function __clone() { trigger_error('Palette cannot be cloned', E_USER_ERROR); } } } ?>
